
HD44780_8bit_LQd_LCD8_EN_hold:

;HD44780_8bit_LQd.mbas,24 :: 		sub procedure LCD8_EN_hold()
;HD44780_8bit_LQd.mbas,27 :: 		NOP
	NOP
;HD44780_8bit_LQd.mbas,28 :: 		NOP
	NOP
;HD44780_8bit_LQd.mbas,29 :: 		NOP
	NOP
;HD44780_8bit_LQd.mbas,30 :: 		NOP
	NOP
;HD44780_8bit_LQd.mbas,31 :: 		NOP
	NOP
;HD44780_8bit_LQd.mbas,33 :: 		end sub
L_end_LCD8_EN_hold:
	RET
; end of HD44780_8bit_LQd_LCD8_EN_hold

_LCD8_check_busy:

;HD44780_8bit_LQd.mbas,35 :: 		sub function LCD8_check_busy() as byte
;HD44780_8bit_LQd.mbas,36 :: 		EN = 0
	IN         R27, PORTC7_bit+0
	CBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,37 :: 		DATAPORT = 0
	LDI        R27, 0
	OUT        PORTA+0, R27
;HD44780_8bit_LQd.mbas,38 :: 		RW = 1
	IN         R27, PORTC6_bit+0
	SBR        R27, 64
	OUT        PORTC6_bit+0, R27
;HD44780_8bit_LQd.mbas,39 :: 		RS = 0
	IN         R27, PORTC5_bit+0
	CBR        R27, 32
	OUT        PORTC5_bit+0, R27
;HD44780_8bit_LQd.mbas,40 :: 		DATAPORT_direction = 0
	LDI        R27, 0
	OUT        DDRA+0, R27
;HD44780_8bit_LQd.mbas,41 :: 		EN = 1
	IN         R27, PORTC7_bit+0
	SBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,42 :: 		LCD8_EN_hold()
	CALL       HD44780_8bit_LQd_LCD8_EN_hold+0
;HD44780_8bit_LQd.mbas,43 :: 		result = PINA
; Result start address is: 17 (R17)
	IN         R17, PINA+0
;HD44780_8bit_LQd.mbas,44 :: 		EN = 0
	IN         R27, PORTC7_bit+0
	CBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,45 :: 		DATAPORT_direction = 0xFF
	LDI        R27, 255
	OUT        DDRA+0, R27
;HD44780_8bit_LQd.mbas,47 :: 		result = result AND %10000000
	MOV        R16, R17
	ANDI       R16, 128
	MOV        R17, R16
;HD44780_8bit_LQd.mbas,48 :: 		end sub
	MOV        R16, R17
; Result end address is: 17 (R17)
L_end_LCD8_check_busy:
	RET
; end of _LCD8_check_busy

_LCD8_Cmd:

;HD44780_8bit_LQd.mbas,50 :: 		sub procedure LCD8_Cmd(dim comm as byte)
;HD44780_8bit_LQd.mbas,51 :: 		while LCD8_check_busy() <> 0
L__LCD8_Cmd4:
	CALL       _LCD8_check_busy+0
	CPI        R16, 0
	BREQ       L__LCD8_Cmd37
	JMP        L__LCD8_Cmd4
L__LCD8_Cmd37:
;HD44780_8bit_LQd.mbas,54 :: 		RW = 0
	IN         R27, PORTC6_bit+0
	CBR        R27, 64
	OUT        PORTC6_bit+0, R27
;HD44780_8bit_LQd.mbas,55 :: 		EN = 0
	IN         R27, PORTC7_bit+0
	CBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,56 :: 		RS = 0
	IN         R27, PORTC5_bit+0
	CBR        R27, 32
	OUT        PORTC5_bit+0, R27
;HD44780_8bit_LQd.mbas,57 :: 		DATAPORT = comm
	OUT        PORTA+0, R2
;HD44780_8bit_LQd.mbas,58 :: 		EN = 1
	IN         R27, PORTC7_bit+0
	SBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,59 :: 		LCD8_EN_hold()
	CALL       HD44780_8bit_LQd_LCD8_EN_hold+0
;HD44780_8bit_LQd.mbas,60 :: 		EN = 0
	IN         R27, PORTC7_bit+0
	CBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,62 :: 		end sub
L_end_LCD8_Cmd:
	RET
; end of _LCD8_Cmd

_LCD8_write_data:

;HD44780_8bit_LQd.mbas,64 :: 		sub procedure LCD8_write_data(dim param as byte)
;HD44780_8bit_LQd.mbas,65 :: 		while LCD8_check_busy() <> 0
L__LCD8_write_data10:
	CALL       _LCD8_check_busy+0
	CPI        R16, 0
	BREQ       L__LCD8_write_data39
	JMP        L__LCD8_write_data10
L__LCD8_write_data39:
;HD44780_8bit_LQd.mbas,68 :: 		RW = 0
	IN         R27, PORTC6_bit+0
	CBR        R27, 64
	OUT        PORTC6_bit+0, R27
;HD44780_8bit_LQd.mbas,69 :: 		EN = 0
	IN         R27, PORTC7_bit+0
	CBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,70 :: 		RS = 1
	IN         R27, PORTC5_bit+0
	SBR        R27, 32
	OUT        PORTC5_bit+0, R27
;HD44780_8bit_LQd.mbas,71 :: 		DATAPORT = param
	OUT        PORTA+0, R2
;HD44780_8bit_LQd.mbas,72 :: 		EN = 1
	IN         R27, PORTC7_bit+0
	SBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,73 :: 		LCD8_EN_hold()
	CALL       HD44780_8bit_LQd_LCD8_EN_hold+0
;HD44780_8bit_LQd.mbas,74 :: 		EN = 0
	IN         R27, PORTC7_bit+0
	CBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,76 :: 		end sub
L_end_LCD8_write_data:
	RET
; end of _LCD8_write_data

_LCD8_Init:

;HD44780_8bit_LQd.mbas,78 :: 		sub procedure LCD8_Init()
;HD44780_8bit_LQd.mbas,79 :: 		Delay_ms(30)
	PUSH       R2
	LDI        R18, 2
	LDI        R17, 56
	LDI        R16, 174
L__LCD8_Init15:
	DEC        R16
	BRNE       L__LCD8_Init15
	DEC        R17
	BRNE       L__LCD8_Init15
	DEC        R18
	BRNE       L__LCD8_Init15
;HD44780_8bit_LQd.mbas,81 :: 		RW = 0
	IN         R27, PORTC6_bit+0
	CBR        R27, 64
	OUT        PORTC6_bit+0, R27
;HD44780_8bit_LQd.mbas,82 :: 		EN = 0
	IN         R27, PORTC7_bit+0
	CBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,83 :: 		RS = 0
	IN         R27, PORTC5_bit+0
	CBR        R27, 32
	OUT        PORTC5_bit+0, R27
;HD44780_8bit_LQd.mbas,84 :: 		DATAPORT = 0x30
	LDI        R27, 48
	OUT        PORTA+0, R27
;HD44780_8bit_LQd.mbas,85 :: 		EN = 1
	IN         R27, PORTC7_bit+0
	SBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,86 :: 		LCD8_EN_hold()
	CALL       HD44780_8bit_LQd_LCD8_EN_hold+0
;HD44780_8bit_LQd.mbas,87 :: 		EN = 0
	IN         R27, PORTC7_bit+0
	CBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,88 :: 		Delay_us(4200)
	LDI        R17, 44
	LDI        R16, 162
L__LCD8_Init17:
	DEC        R16
	BRNE       L__LCD8_Init17
	DEC        R17
	BRNE       L__LCD8_Init17
	NOP
;HD44780_8bit_LQd.mbas,90 :: 		DATAPORT = 0x30
	LDI        R27, 48
	OUT        PORTA+0, R27
;HD44780_8bit_LQd.mbas,91 :: 		EN = 1
	IN         R27, PORTC7_bit+0
	SBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,92 :: 		LCD8_EN_hold()
	CALL       HD44780_8bit_LQd_LCD8_EN_hold+0
;HD44780_8bit_LQd.mbas,93 :: 		EN = 0
	IN         R27, PORTC7_bit+0
	CBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,94 :: 		Delay_us(120)
	LDI        R17, 2
	LDI        R16, 62
L__LCD8_Init19:
	DEC        R16
	BRNE       L__LCD8_Init19
	DEC        R17
	BRNE       L__LCD8_Init19
	NOP
;HD44780_8bit_LQd.mbas,96 :: 		DATAPORT = 0x30
	LDI        R27, 48
	OUT        PORTA+0, R27
;HD44780_8bit_LQd.mbas,97 :: 		EN = 1
	IN         R27, PORTC7_bit+0
	SBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,98 :: 		LCD8_EN_hold()
	CALL       HD44780_8bit_LQd_LCD8_EN_hold+0
;HD44780_8bit_LQd.mbas,99 :: 		EN = 0
	IN         R27, PORTC7_bit+0
	CBR        R27, 128
	OUT        PORTC7_bit+0, R27
;HD44780_8bit_LQd.mbas,100 :: 		Delay_us(120)
	LDI        R17, 2
	LDI        R16, 62
L__LCD8_Init21:
	DEC        R16
	BRNE       L__LCD8_Init21
	DEC        R17
	BRNE       L__LCD8_Init21
	NOP
;HD44780_8bit_LQd.mbas,106 :: 		LCD8_Cmd(0x38)
	LDI        R27, 56
	MOV        R2, R27
	CALL       _LCD8_Cmd+0
;HD44780_8bit_LQd.mbas,107 :: 		LCD8_Cmd(0x08)
	LDI        R27, 8
	MOV        R2, R27
	CALL       _LCD8_Cmd+0
;HD44780_8bit_LQd.mbas,108 :: 		LCD8_Cmd(0x01)
	LDI        R27, 1
	MOV        R2, R27
	CALL       _LCD8_Cmd+0
;HD44780_8bit_LQd.mbas,109 :: 		LCD8_Cmd(0x06)
	LDI        R27, 6
	MOV        R2, R27
	CALL       _LCD8_Cmd+0
;HD44780_8bit_LQd.mbas,110 :: 		LCD8_Cmd(0x0C)
	LDI        R27, 12
	MOV        R2, R27
	CALL       _LCD8_Cmd+0
;HD44780_8bit_LQd.mbas,112 :: 		end sub
L_end_LCD8_Init:
	POP        R2
	RET
; end of _LCD8_Init

_LCD8_Chr_CP:

;HD44780_8bit_LQd.mbas,114 :: 		sub procedure LCD8_Chr_CP(dim character as byte)
;HD44780_8bit_LQd.mbas,115 :: 		LCD8_write_data(character)
	CALL       _LCD8_write_data+0
;HD44780_8bit_LQd.mbas,116 :: 		end sub
L_end_LCD8_Chr_CP:
	RET
; end of _LCD8_Chr_CP

_LCD8_1line:

;HD44780_8bit_LQd.mbas,118 :: 		sub procedure LCD8_1line()
;HD44780_8bit_LQd.mbas,119 :: 		LCD8_Cmd(0x80)
	PUSH       R2
	LDI        R27, 128
	MOV        R2, R27
	CALL       _LCD8_Cmd+0
;HD44780_8bit_LQd.mbas,120 :: 		end sub
L_end_LCD8_1line:
	POP        R2
	RET
; end of _LCD8_1line

_LCD8_2line:

;HD44780_8bit_LQd.mbas,122 :: 		sub procedure LCD8_2line()
;HD44780_8bit_LQd.mbas,123 :: 		LCD8_Cmd(0xC0)
	PUSH       R2
	LDI        R27, 192
	MOV        R2, R27
	CALL       _LCD8_Cmd+0
;HD44780_8bit_LQd.mbas,124 :: 		end sub
L_end_LCD8_2line:
	POP        R2
	RET
; end of _LCD8_2line

_LCD8_3line:

;HD44780_8bit_LQd.mbas,126 :: 		sub procedure LCD8_3line()
;HD44780_8bit_LQd.mbas,127 :: 		LCD8_Cmd(0x94)
	PUSH       R2
	LDI        R27, 148
	MOV        R2, R27
	CALL       _LCD8_Cmd+0
;HD44780_8bit_LQd.mbas,128 :: 		end sub
L_end_LCD8_3line:
	POP        R2
	RET
; end of _LCD8_3line

_LCD8_4line:

;HD44780_8bit_LQd.mbas,130 :: 		sub procedure LCD8_4line()
;HD44780_8bit_LQd.mbas,131 :: 		LCD8_Cmd(0xD4)
	PUSH       R2
	LDI        R27, 212
	MOV        R2, R27
	CALL       _LCD8_Cmd+0
;HD44780_8bit_LQd.mbas,132 :: 		end sub
L_end_LCD8_4line:
	POP        R2
	RET
; end of _LCD8_4line

_LCD8_CustomChar:

;HD44780_8bit_LQd.mbas,139 :: 		dim n as byte
;HD44780_8bit_LQd.mbas,140 :: 		Lcd8_Cmd(0x40 + (possition*8))
	PUSH       R2
	MOV        R16, R2
	LSL        R16
	LSL        R16
	LSL        R16
	SUBI       R16, 192
	MOV        R2, R16
	CALL       _LCD8_Cmd+0
;HD44780_8bit_LQd.mbas,141 :: 		for n = 0 to 7
; n start address is: 17 (R17)
	LDI        R17, 0
; n end address is: 17 (R17)
L__LCD8_CustomChar30:
;HD44780_8bit_LQd.mbas,142 :: 		Lcd8_Chr_CP(character[n])
; n start address is: 17 (R17)
	MOV        R30, R17
	LDI        R31, 0
	ADD        R30, R3
	ADC        R31, R4
	LD         R16, Z
	PUSH       R17
	PUSH       R2
	MOV        R2, R16
	CALL       _LCD8_Chr_CP+0
	POP        R2
	POP        R17
;HD44780_8bit_LQd.mbas,143 :: 		next n
	CPI        R17, 7
	BRNE       L__LCD8_CustomChar47
	JMP        L__LCD8_CustomChar33
L__LCD8_CustomChar47:
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
; n end address is: 17 (R17)
	JMP        L__LCD8_CustomChar30
L__LCD8_CustomChar33:
;HD44780_8bit_LQd.mbas,144 :: 		Lcd8_Cmd(0x80)
	PUSH       R2
	LDI        R27, 128
	MOV        R2, R27
	CALL       _LCD8_Cmd+0
	POP        R2
;HD44780_8bit_LQd.mbas,145 :: 		end sub
L_end_LCD8_CustomChar:
	POP        R2
	RET
; end of _LCD8_CustomChar

_HD44780_8bit_LQd_?main:

;HD44780_8bit_LQd.mbas,149 :: 		end.
L_end_HD44780_8bit_LQd_?main:
	RET
; end of _HD44780_8bit_LQd_?main
